﻿#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Change2CUI=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#Region ;************ Includes ************
#include <AutoItConstants.au3>
#include <FileConstants.au3>
#include <MsgBoxConstants.au3>
;~ #Include <Array.au3>
;~ #Include <File>
;~ #Include <WinAPIShPath.au3>
#EndRegion ;************ Includes ************

;-- TIME_STAMP   2017-06-29 06:48:33   v 0.1

Global $sSpacer = '----------------------------------------------------------------------------------------------------------------' & @CRLF

; Changes the current working directory.
FileChangeDir(@ScriptDir)
_CmdWrite('- ' & $sSpacer & '- working directory: ' & @WorkingDir & @CRLF & '- ' & $sSpacer & @CRLF)

Local $sFile, $sFilePath = @ScriptDir & '\Anna.txt' ; Codierung: Westeuropäisch (Windows) (Codepage = 1251)

_Demo_DOS_Befehl()
_Demo_SAP_File()

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; SAP - Einstellung für die Upload-/Download-Codierung: Westeuropäisch (Windows) (Codepage = 1251)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Func _Demo_SAP_File()
	; Dateien mit AutoIt einlesen
	Local $sFile = _GetFileFromSAP($sFilePath)
	If @error Then Exit 1
	_CmdWrite('! ' & $sSpacer & '> Dateiname: ' & $sFilePath & @CRLF & '> Anzahl der eingelesenen Zeichen: ' & @extended & @CRLF & '! ' & $sSpacer & $sFile & @CRLF & '- ' & $sSpacer & @CRLF)

	; Inhalt der Datei ändern und Kopie unter anderem Namen speichern.
	$sFilePath = _PathRenameExtension($sFilePath, _PathFindExtension($sFilePath) & '.bak')
	$sFile = StringReplace(StringReplace($sFile, 'Anna', 'Susi'), 'Maria', 'Nicole')
	_SaveFile($sFilePath, $sFile)
	If @error Then Exit 2
	_CmdWrite('! ' & $sSpacer & '> Neuer Dateiname: ' & $sFilePath & @CRLF & '> Anzahl der geschriebenen Zeichen: ' & @extended & @CRLF & '! ' & $sSpacer & $sFile & @CRLF & '- ' & $sSpacer)
EndFunc

Func _GetFileFromSAP($sFilePath)
	; Open the file for reading and store the handle to a variable.
	Local $hFileOpen = FileOpen($sFilePath, BitOR($FO_READ, $FO_ANSI)) ; $FO_ANSI (512) = Use ANSI reading and writing mode.

	If $hFileOpen = -1 Then
		MsgBox($MB_SYSTEMMODAL, "", "An error occurred when reading the file.")
		Return SetError(1, 0, False)
	EndIf

	; Read the contents of the file using the handle returned by FileOpen.
	Local $sFileRead = FileRead($hFileOpen), $iExtended = @extended

	; Close the handle returned by FileOpen.
	FileClose($hFileOpen)

	; Number of characters read in @extended
	Return SetExtended($iExtended, $sFileRead)
EndFunc   ;==>_GetFileFromSAP

Func _SaveFile($sFilePath, $sStr, $FO_DEFAULT = BitOR($FO_OVERWRITE, $FO_ANSI))
	; Open the file for reading and store the handle to a variable.
	Local $hFileOpen = FileOpen($sFilePath, $FO_DEFAULT) ; $FO_ANSI (512) = Use ANSI reading and writing mode.

	If $hFileOpen = -1 Then
		MsgBox($MB_SYSTEMMODAL, "", "An error occurred when opening the file.")
		Return SetError(1, 0, False)
	EndIf

	; Wriite the contents of the file using the handle returned by FileOpen.
	Local $sFileWrite = FileWrite($hFileOpen, $sStr)

	; Close the handle returned by FileOpen.
	FileClose($hFileOpen)

	; Number of characters write in @extended
	Return SetExtended(FileGetSize($sFilePath), $sFileWrite)
EndFunc   ;==>_SaveFile

; Text in der SciTE-Console oder in der CMD-Console (CMD.exe) ausgeben - die Umlaute sollten in beiden Fällen korrekt dargestellt werden!
; If @Compiled = 0 - der Text wird in der SciTE-Console ausgegeben. Der Text muss für die Ausgabe NICHT konvertiert werden!
; If @Compiled = 1 - der Text wird in der CMD-Console ausgegeben. Der Text muss für die Ausgabe konvertiert werden!
Func _CmdWrite($sStr)
	Local $iConvert, $iExtended, $sCHAR = _OemToChar($sStr), $sOEM = _CharToOem($sStr)

	Select
		Case StringRegExpReplace($sCHAR, '[äöüßÄÖÜ]', '') <> $sStr ; $sStr = OEM
			$iConvert = (@extended > 0) ? 1 : 0
		Case StringRegExpReplace($sOEM, '[äöüßÄÖÜ]', '') <> $sStr ; $sStr = ANSI
			$iConvert = (@extended > 0) ? 2 : 0
		Case Else
			$iConvert = 0 ; Keine Umlaute enthalten, somit muss in keinem Fall konvertiert werden!
	EndSelect

	Switch @Compiled
		Case 0 ; Ausgabe in SciTE-Console
			Switch $iConvert
				Case 0, 2
					ConsoleWrite('!  (1) $iConvert  = ' & $iConvert & @CRLF & $sStr)
				Case Else
					ConsoleWrite('!  (2) $iConvert  = ' & $iConvert & @CRLF & $sCHAR)
			EndSwitch
		Case 1 ; Ausgabe In CMD-Console
			Switch $iConvert
				Case 0
					ConsoleWrite('!  (4) $iConvert  = ' & $iConvert & @CRLF & $sOEM)
				Case Else
					ConsoleWrite('!  (3) $iConvert  = ' & $iConvert & @CRLF & $sStr)
			EndSwitch
	EndSwitch
EndFunc   ;==>_CmdWrite

Func _CharToOem($sStr)
	Local $aRet = DllCall('user32.dll', 'bool', 'CharToOem', 'str', $sStr, 'str', '')
	If @error Or Not $aRet[0] Then Return SetError(@error + 10, @extended, '')

	Return $aRet[2]
EndFunc   ;==>_CharToOem

; _WinAPI_OemToChar
Func _OemToChar($sStr)
	Local $aRet = DllCall('user32.dll', 'bool', 'OemToChar', 'str', $sStr, 'str', '')
	If @error Or Not $aRet[0] Then Return SetError(@error + 10, @extended, '')

	Return $aRet[2]
EndFunc   ;==>_OemToChar

; _WinAPI_PathRenameExtension
Func _PathRenameExtension($sFilePath, $sExt)
	Local $tPath = DllStructCreate('wchar[260]') ; as described in MSDN
	DllStructSetData($tPath, 1, $sFilePath)

	Local $aRet = DllCall('shlwapi.dll', 'bool', 'PathRenameExtensionW', 'struct*', $tPath, 'wstr', $sExt)
	If @error Or Not $aRet[0] Then Return SetError(@error, @extended, '')
	; If Not $aRet[0] Then Return SetError(1000, 0, '')

	Return DllStructGetData($tPath, 1)
EndFunc   ;==>_PathRenameExtension

; _WinAPI_PathFindExtension
Func _PathFindExtension($sFilePath)
	Local $aRet = DllCall('shlwapi.dll', 'wstr', 'PathFindExtensionW', 'wstr', $sFilePath)
	If @error Then Return SetError(@error, @extended, '')

	Return $aRet[0]
EndFunc   ;==>_PathFindExtension

; _WinAPI_PathRemoveExtension
Func _PathRemoveExtension($sFilePath)
	Local $aRet = DllCall('shlwapi.dll', 'none', 'PathRemoveExtensionW', 'wstr', $sFilePath)
	If @error Then Return SetError(@error, @extended, '')

	Return $aRet[1]
EndFunc   ;==>_PathRemoveExtension

; _WinAPI_PathStripPath
Func _PathStripPath($sFilePath)
	Local $aRet = DllCall('shlwapi.dll', 'none', 'PathStripPathW', 'wstr', $sFilePath)
	If @error Then Return SetError(@error, @extended, '')

	Return $aRet[1]
EndFunc   ;==>_PathStripPath

Func _Demo_DOS_Befehl()
	Local $sCMD = StringFormat('"%s" "%s "%s""', @ComSpec, '/c Dir /A-D /S', $sFilePath)

	Local $iPID = Run($sCMD, "", @SW_HIDE, $STDOUT_CHILD)
	ProcessWaitClose($iPID)
	Local $sOutput = StdoutRead($iPID)
	_CmdWrite('- ' & $sSpacer & $sOutput & '- ' & $sSpacer)
	_CmdWrite('- ' & $sSpacer & 'äöüßÄÖÜ' & @CRLF & '- ' & $sSpacer)
EndFunc   ;==>_Demo_DOS_Befehl
